// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/keycloak/keycloak-operator/pkg/apis/keycloak/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKeycloakBackups implements KeycloakBackupInterface
type FakeKeycloakBackups struct {
	Fake *FakeKeycloakV1alpha1
	ns   string
}

var keycloakbackupsResource = schema.GroupVersionResource{Group: "keycloak.org", Version: "v1alpha1", Resource: "keycloakbackups"}

var keycloakbackupsKind = schema.GroupVersionKind{Group: "keycloak.org", Version: "v1alpha1", Kind: "KeycloakBackup"}

// Get takes name of the keycloakBackup, and returns the corresponding keycloakBackup object, and an error if there is any.
func (c *FakeKeycloakBackups) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.KeycloakBackup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(keycloakbackupsResource, c.ns, name), &v1alpha1.KeycloakBackup{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakBackup), err
}

// List takes label and field selectors, and returns the list of KeycloakBackups that match those selectors.
func (c *FakeKeycloakBackups) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.KeycloakBackupList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(keycloakbackupsResource, keycloakbackupsKind, c.ns, opts), &v1alpha1.KeycloakBackupList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.KeycloakBackupList{ListMeta: obj.(*v1alpha1.KeycloakBackupList).ListMeta}
	for _, item := range obj.(*v1alpha1.KeycloakBackupList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested keycloakBackups.
func (c *FakeKeycloakBackups) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(keycloakbackupsResource, c.ns, opts))

}

// Create takes the representation of a keycloakBackup and creates it.  Returns the server's representation of the keycloakBackup, and an error, if there is any.
func (c *FakeKeycloakBackups) Create(ctx context.Context, keycloakBackup *v1alpha1.KeycloakBackup, opts v1.CreateOptions) (result *v1alpha1.KeycloakBackup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(keycloakbackupsResource, c.ns, keycloakBackup), &v1alpha1.KeycloakBackup{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakBackup), err
}

// Update takes the representation of a keycloakBackup and updates it. Returns the server's representation of the keycloakBackup, and an error, if there is any.
func (c *FakeKeycloakBackups) Update(ctx context.Context, keycloakBackup *v1alpha1.KeycloakBackup, opts v1.UpdateOptions) (result *v1alpha1.KeycloakBackup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(keycloakbackupsResource, c.ns, keycloakBackup), &v1alpha1.KeycloakBackup{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakBackup), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeKeycloakBackups) UpdateStatus(ctx context.Context, keycloakBackup *v1alpha1.KeycloakBackup, opts v1.UpdateOptions) (*v1alpha1.KeycloakBackup, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(keycloakbackupsResource, "status", c.ns, keycloakBackup), &v1alpha1.KeycloakBackup{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakBackup), err
}

// Delete takes name of the keycloakBackup and deletes it. Returns an error if one occurs.
func (c *FakeKeycloakBackups) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(keycloakbackupsResource, c.ns, name), &v1alpha1.KeycloakBackup{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKeycloakBackups) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(keycloakbackupsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.KeycloakBackupList{})
	return err
}

// Patch applies the patch and returns the patched keycloakBackup.
func (c *FakeKeycloakBackups) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.KeycloakBackup, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(keycloakbackupsResource, c.ns, name, pt, data, subresources...), &v1alpha1.KeycloakBackup{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakBackup), err
}
