// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/keycloak/keycloak-operator/pkg/apis/keycloak/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKeycloakRealms implements KeycloakRealmInterface
type FakeKeycloakRealms struct {
	Fake *FakeKeycloakV1alpha1
	ns   string
}

var keycloakrealmsResource = schema.GroupVersionResource{Group: "keycloak.org", Version: "v1alpha1", Resource: "keycloakrealms"}

var keycloakrealmsKind = schema.GroupVersionKind{Group: "keycloak.org", Version: "v1alpha1", Kind: "KeycloakRealm"}

// Get takes name of the keycloakRealm, and returns the corresponding keycloakRealm object, and an error if there is any.
func (c *FakeKeycloakRealms) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.KeycloakRealm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(keycloakrealmsResource, c.ns, name), &v1alpha1.KeycloakRealm{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakRealm), err
}

// List takes label and field selectors, and returns the list of KeycloakRealms that match those selectors.
func (c *FakeKeycloakRealms) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.KeycloakRealmList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(keycloakrealmsResource, keycloakrealmsKind, c.ns, opts), &v1alpha1.KeycloakRealmList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.KeycloakRealmList{ListMeta: obj.(*v1alpha1.KeycloakRealmList).ListMeta}
	for _, item := range obj.(*v1alpha1.KeycloakRealmList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested keycloakRealms.
func (c *FakeKeycloakRealms) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(keycloakrealmsResource, c.ns, opts))

}

// Create takes the representation of a keycloakRealm and creates it.  Returns the server's representation of the keycloakRealm, and an error, if there is any.
func (c *FakeKeycloakRealms) Create(ctx context.Context, keycloakRealm *v1alpha1.KeycloakRealm, opts v1.CreateOptions) (result *v1alpha1.KeycloakRealm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(keycloakrealmsResource, c.ns, keycloakRealm), &v1alpha1.KeycloakRealm{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakRealm), err
}

// Update takes the representation of a keycloakRealm and updates it. Returns the server's representation of the keycloakRealm, and an error, if there is any.
func (c *FakeKeycloakRealms) Update(ctx context.Context, keycloakRealm *v1alpha1.KeycloakRealm, opts v1.UpdateOptions) (result *v1alpha1.KeycloakRealm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(keycloakrealmsResource, c.ns, keycloakRealm), &v1alpha1.KeycloakRealm{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakRealm), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeKeycloakRealms) UpdateStatus(ctx context.Context, keycloakRealm *v1alpha1.KeycloakRealm, opts v1.UpdateOptions) (*v1alpha1.KeycloakRealm, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(keycloakrealmsResource, "status", c.ns, keycloakRealm), &v1alpha1.KeycloakRealm{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakRealm), err
}

// Delete takes name of the keycloakRealm and deletes it. Returns an error if one occurs.
func (c *FakeKeycloakRealms) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(keycloakrealmsResource, c.ns, name), &v1alpha1.KeycloakRealm{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKeycloakRealms) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(keycloakrealmsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.KeycloakRealmList{})
	return err
}

// Patch applies the patch and returns the patched keycloakRealm.
func (c *FakeKeycloakRealms) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.KeycloakRealm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(keycloakrealmsResource, c.ns, name, pt, data, subresources...), &v1alpha1.KeycloakRealm{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakRealm), err
}
