// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/keycloak/keycloak-operator/pkg/apis/keycloak/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKeycloakUsers implements KeycloakUserInterface
type FakeKeycloakUsers struct {
	Fake *FakeKeycloakV1alpha1
	ns   string
}

var keycloakusersResource = schema.GroupVersionResource{Group: "keycloak.org", Version: "v1alpha1", Resource: "keycloakusers"}

var keycloakusersKind = schema.GroupVersionKind{Group: "keycloak.org", Version: "v1alpha1", Kind: "KeycloakUser"}

// Get takes name of the keycloakUser, and returns the corresponding keycloakUser object, and an error if there is any.
func (c *FakeKeycloakUsers) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.KeycloakUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(keycloakusersResource, c.ns, name), &v1alpha1.KeycloakUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakUser), err
}

// List takes label and field selectors, and returns the list of KeycloakUsers that match those selectors.
func (c *FakeKeycloakUsers) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.KeycloakUserList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(keycloakusersResource, keycloakusersKind, c.ns, opts), &v1alpha1.KeycloakUserList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.KeycloakUserList{ListMeta: obj.(*v1alpha1.KeycloakUserList).ListMeta}
	for _, item := range obj.(*v1alpha1.KeycloakUserList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested keycloakUsers.
func (c *FakeKeycloakUsers) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(keycloakusersResource, c.ns, opts))

}

// Create takes the representation of a keycloakUser and creates it.  Returns the server's representation of the keycloakUser, and an error, if there is any.
func (c *FakeKeycloakUsers) Create(ctx context.Context, keycloakUser *v1alpha1.KeycloakUser, opts v1.CreateOptions) (result *v1alpha1.KeycloakUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(keycloakusersResource, c.ns, keycloakUser), &v1alpha1.KeycloakUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakUser), err
}

// Update takes the representation of a keycloakUser and updates it. Returns the server's representation of the keycloakUser, and an error, if there is any.
func (c *FakeKeycloakUsers) Update(ctx context.Context, keycloakUser *v1alpha1.KeycloakUser, opts v1.UpdateOptions) (result *v1alpha1.KeycloakUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(keycloakusersResource, c.ns, keycloakUser), &v1alpha1.KeycloakUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakUser), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeKeycloakUsers) UpdateStatus(ctx context.Context, keycloakUser *v1alpha1.KeycloakUser, opts v1.UpdateOptions) (*v1alpha1.KeycloakUser, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(keycloakusersResource, "status", c.ns, keycloakUser), &v1alpha1.KeycloakUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakUser), err
}

// Delete takes name of the keycloakUser and deletes it. Returns an error if one occurs.
func (c *FakeKeycloakUsers) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(keycloakusersResource, c.ns, name), &v1alpha1.KeycloakUser{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKeycloakUsers) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(keycloakusersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.KeycloakUserList{})
	return err
}

// Patch applies the patch and returns the patched keycloakUser.
func (c *FakeKeycloakUsers) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.KeycloakUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(keycloakusersResource, c.ns, name, pt, data, subresources...), &v1alpha1.KeycloakUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.KeycloakUser), err
}
